<?php
/** 
*
* @package phpBB3
* @version $Id: thanks.php,v 0.1 PR1 2007/10/01 16:09:31 nE0sIghT Exp $
* @copyright (c) 2007 nE0sIghT
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit; 
}
define('THANKS_TABLE', $table_prefix . 'thanks');

// Do stuff based on header variables
// Two variables are needed to avoid accidental refresh errors
if (isset($_REQUEST['thanks']) && !isset($_REQUEST['rthanks'])) 
{
	insert_thanks(request_var('thanks', 0), $user->data['user_id']);
}
if (isset($_REQUEST['rthanks']) && !isset($_REQUEST['thanks']))
{
	delete_thanks(request_var('rthanks', 0), $user->data['user_id']);
}


// create an array of all thanks info
$thanks_sql = 'SELECT *
	FROM ' . THANKS_TABLE;
$thanks_result = $db->sql_query($thanks_sql);
$thankers = array();
$thanks_i = 0;
while ($thanks_row = $db->sql_fetchrow($thanks_result))
{
	$thankers[$thanks_i] = array(  
		'user_id' => $thanks_row['user_id'], 
		'post_id' => $thanks_row['post_id'], 
	);
	$thanks_i++;
}
$db->sql_freeresult($thanks_result);

// Output thanks list
function get_thanks($post_id)
{
	global $db, $users, $poster_id;

	$sql = 'SELECT u.user_id, u.username, u.user_colour
		FROM ' . THANKS_TABLE . ' th, ' . USERS_TABLE . " u
		WHERE th.post_id = $post_id
			AND u.user_id = th.user_id";
	$result = $db->sql_query($sql);

	$return = '';
	while($row = $db->sql_fetchrow($result))
	{
		if(!empty($return))
		{
			$return .= ', ';
		}
		$return .= get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'], $row['username']);
	}
	$db->sql_freeresult($result);

	return $return;
}

function get_thanks_number($post_id)
{
	global $db;

	$sql = 'SELECT COUNT(*) AS `count`
		FROM ' . THANKS_TABLE . "
		WHERE post_id = $post_id";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $row['count'];
}

// add a user to the thanks list
function insert_thanks($post_id, $user_id)
{
	global $db, $users;
	if ($user_id != ANONYMOUS)
	{
		$sql = 'SELECT *
			FROM ' . THANKS_TABLE . "
			WHERE post_id = $post_id 
				AND user_id = $user_id
			LIMIT 1";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		$to_id = request_var('to_id', 0);
		if (empty($row) && !empty($to_id) && $to_id != $user_id)
		{
			$sql2 = 'INSERT INTO ' . THANKS_TABLE . ' ' . $db->sql_build_array('INSERT', array(
				'user_id'	=> $user_id,
				'user_to_id'	=> $to_id,
				'post_id'	=> $post_id,
				'thanks_time'	=> time()
			));
			$db->sql_query($sql2);
		}
	}
}
// remove a user's thanks
function delete_thanks($post_id, $user_id)
{
	global $db, $user, $users;
	if ($user_id != ANONYMOUS)
	{
		$sql = 'SELECT *
			FROM ' . THANKS_TABLE . "
			WHERE post_id = $post_id AND user_id = $user_id
			LIMIT 1";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		$to_id = request_var('to_id', 0);
		if (!empty($row) && !empty($to_id))
		{
			$sql = "DELETE FROM " . THANKS_TABLE . "
				WHERE post_id = $post_id AND user_id = " . $user->data['user_id'];
			$db->sql_query($sql);
		}
	}
}
// display the text/image saying either to add or remove thanks
function get_thanks_text($post_id)
{
	global $db, $user, $postrow;

	if(already_thanked($post_id, $user->data['user_id']))
	{
		$postrow = array_merge($postrow, array(
			'THANK_ALT'		=> $user->lang['REMOVE_THANKS'],
			'THANK_ALT2'	=> $user->lang['THANK_POST2'],
			'THANKS_IMG'	=> '/icon_post_rthanks.gif'
		));
		return;
	}
	$postrow = array_merge($postrow, array(
		'THANK_ALT'		=> $user->lang['THANK_POST1'],
		'THANK_ALT2'	=> $user->lang['THANK_POST2'],
		'THANKS_IMG'	=> '/icon_post_thanks.gif'
	));
	return;
}
// change the variable sent via the link to avoid odd errors
function get_thanks_link($post_id)
{
	global $user;
	if (already_thanked($post_id, $user->data['user_id']))
	{
		return 'rthanks';
	}
	return 'thanks';
}
// check if the user has already thanked that post
function already_thanked($post_id, $user_id)
{
	global $db;

	$thanked = false;

	$sql = 'SELECT *
		FROM ' . THANKS_TABLE . "
		WHERE post_id = $post_id 
			AND user_id = $user_id
		LIMIT 1";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	if(!empty($row))
	{
		$thanked = true;
	}

	return $thanked;
}
// check gender in applicable
function get_gender($user_id)
{
	global $users, $user;
	if ($user_id == ANONYMOUS || $users[$user_id]['user_gender'] == false)
	{
		return $user->lang['THANK_GENDER_U'];
	}
	else if ($users[$user_id]['user_gender'] == 1)
	{
		return $user->lang['THANK_GENDER_M'];
	}
	else if ($users[$user_id]['user_gender'] == 2)
	{
		return $user->lang['THANK_GENDER_F'];
	}
	return $user->lang['THANK_GENDER_U'];
}

// gets the number of users that have thanked the poster
function get_user_count($user_id, $receive)
{
	global $users, $db;

	$sql = 'SELECT *
		FROM ' . THANKS_TABLE;

	if($receive)
	{
		$sql .= " WHERE user_to_id = $user_id";
	}
	else
	{
		$sql .= " WHERE user_id = $user_id";
	}

	$result = $db->sql_query($sql);
	$db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $db->sql_affectedrows();

}
// stuff goes here to avoid over-editing viewtopic.php
function output_thanks($user_id)
{
	global $db, $user, $poster_id, $postrow, $row, $phpEx, $topic_data, $phpbb_root_path, $server_path;

	if (!empty($postrow))
	{
		$forum_id = (isset($forum_id)) ? $forum_id : 0;
		$number = get_thanks_number($row['post_id']) . ' ';
		$pl_text = $user->lang['THANK_TEXT_2pl'];
		if ($number == 1)
		{
			$pl_text = $user->lang['THANK_TEXT_2'];
			$number = '';
		}
		get_thanks_text($row['post_id']);
		$postrow = array_merge($postrow, array(
			'THANKS_GENDER' 		=> ' ' . get_gender($user_id),
			'THANKS'			=> get_thanks($row['post_id']),
			'THANKS_LINK'			=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'p=' . $row['post_id']) . (($topic_data['topic_type'] == POST_GLOBAL) ? '&amp;f=' . $forum_id : '') . '&amp;' . get_thanks_link($row['post_id']) . '=' . $row['post_id'] . '&amp;to_id=' . $poster_id . '#p' . $row['post_id'],
			'THANK_TEXT'			=> $user->lang['THANK_TEXT_1'] . ' ' . $pl_text . ' ',
			'POSTER_RECEIVE_COUNT'		=> get_user_count($poster_id, true),
			'U_POSTER_RECEIVE_LINK'		=> "{$server_path}memberlist.$phpEx?mode=viewthanks&amp;u=$user_id",
			'POSTER_GIVE_COUNT'		=> get_user_count($poster_id, false),
			'S_IS_OWN_POST'			=> ($user->data['user_id'] == $poster_id) ? true : false,
		));
	}
}

function output_view_thanks($user_id)
{
	global $template, $server_path, $phpEx;

	$template->assign_vars(array(
		'POSTER_RECEIVE_COUNT'		=> get_user_count($user_id, true),
		'POSTER_GIVE_COUNT'		=> get_user_count($user_id, false),
		'U_POSTER_RECEIVE_LINK'		=> "{$server_path}memberlist.$phpEx?mode=viewthanks&amp;u=$user_id"
	));
}

function output_user_thanks($user_id)
{
	global $db, $template, $server_path, $phpEx;
	$bbcode = new bbcode();

	$sql = 'SELECT t.topic_id, t.topic_title, t.forum_id, p.post_id, p.post_subject, p.post_text, p.post_time, p.bbcode_uid, p.bbcode_bitfield
		FROM ' . POSTS_TABLE . ' p, ' . TOPICS_TABLE . ' t, ' . THANKS_TABLE . " th
		WHERE th.user_to_id = $user_id
			AND p.post_id = th.post_id
			AND t.topic_id = p.topic_id
		ORDER BY p.post_time, th.thanks_time DESC";
	$result = $db->sql_query($sql);

	$thanksrow = array();
	$posts = array();
	while ($row = $db->sql_fetchrow($result))
	{
		if(!in_array($row['post_id'], $posts))
		{
			$posts[] = $row['post_id'];

			// Parse the message and subject
			$message = censor_text($row['post_text']);

			// Second parse bbcode here
			if ($row['bbcode_bitfield'])
			{
				$bbcode->bbcode_second_pass($message, $row['bbcode_uid'], $row['bbcode_bitfield']);
			}

			$message = str_replace("\n", '<br />', $message);

			// Always process smilies after parsing bbcodes
			$message = smiley_text($message);

			$thanksrow = array_merge($thanksrow, array(
				'THANKS_TIME'		=> date("d.m.Y H:i", $row['post_time']),
				'U_THANKS_TOPIC' 	=> "{$server_path}viewtopic.$phpEx?f={$row['forum_id']}&amp;t={$row['topic_id']}",
				'THANKS_TOPIC_TITLE' 	=> censor_text($row['topic_title']),
				'THANKS_POST'		=> $message,
				'THANKS'		=> get_thanks($row['post_id']))
			);

			$template->assign_block_vars('thanksrow', $thanksrow);
		}
	}
	$db->sql_freeresult($result);

	$sql = 'SELECT username
		FROM ' . USERS_TABLE . "
		WHERE user_id = $user_id
		LIMIT 1";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	$template->assign_vars(array(
		'POSTER_RECEIVE_COUNT'	=> get_user_count($user_id, true),
		'POSTER_GIVE_COUNT'	=> get_user_count($user_id, false),
		'USERNAME'		=> $row['username'],
		'TOTAL_THANKS'		=> get_user_count($user_id, true)
	));
}

?>